/*
 *  Copyright (C) 2015  Thadeu Lima de Souza Cascardo <cascardo@minaslivre.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include "util.h"
#include <stdlib.h>
#include <errno.h>
#include <string.h>

int set_llong(char *str, long long *val)
{
	char *end = NULL;
	errno = 0;
	*val = strtoll(str, &end, 0);
	if (end && *end)
		return -EINVAL;
	if (errno == ERANGE)
		return -ERANGE;
	return 0;
}

int set_int(char **args, int argc, int *val)
{
	char *end = NULL;
	if (argc != 2)
		return -EINVAL;
	errno = 0;
	*val = strtol(args[1], &end, 0);
	if (end && *end)
		return -EINVAL;
	if (errno == ERANGE)
		return -ERANGE;
	return 0;
}

int set_string(char **args, int argc, char **str)
{
	if (argc != 2)
		return -EINVAL;
	*str = strdup(args[1]);
	if (!*str)
		return -errno;
	return 0;
}
